//+------------------------------------------------------------------+
//|                                           H1-TrendFishing-EA.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern bool       Use_MA_Trail=True;
extern bool       UseCandleTrail=False;
extern bool       UseTrailingStop=False;
extern int        WhenToTrail=20;
extern int        TrailAmount=10; 
extern bool       UseMoveToBreakEven=False;
extern int        WhenToMoveToBE=20;
extern int        PipsToLockIn=3;

extern int        PadAmount=0;
extern int        CandlesBack=5;

extern double     RiskPercent=2;
extern double     RewardRatio=2;
extern double     FirsTarget=1;

extern int        FastMa=9;
int               FastMaShift=0;
int               FastMaMethod=1;
int               FastMaAppliedTo=0;

extern int        SlowMa=21;
int               SlowMaShift=0;
int               SlowMaMethod=1;
int               SlowMaAppliedTo=0;

//extern int        TrailMa=65;
//int               TrailMaShift=0;
//int               TrailMaMethod=1;
//int               TrailMaAppliedTo=0;



double            pips;
extern int        MagicNumber = 1234;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {

   double ticksize = MarketInfo(Symbol(), MODE_TICKSIZE);
   if (ticksize == 0.00001 || ticksize == 0.001)
   pips = ticksize*10;
   else pips = ticksize;  
   

   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
  {
//----
   if(OpenOrdersThisPair(Symbol())>=1)
      {
      if(UseMoveToBreakEven)MoveToBreakEven();
      if(UseTrailingStop)AdjustTrail();
      if(Use_MA_Trail)MA_Trail();
      }
      if(IsNewCandle())CheckForMaTrade();
      if(CheckForMaTrade())ConsolidatedTrigger(); // NEW CODE LINE.
//----
   return(0);
  }
//+------------------------------------------------------------------+
  
void MoveToBreakEven()
{
for(int b=OrdersTotal()-1; b >=0; b--)
   {
   if(OrderSelect(b,SELECT_BY_POS,MODE_TRADES))
      if(OrderMagicNumber()==MagicNumber)
         if(OrderSymbol()==Symbol())
            if(OrderType()==OP_BUY)
                if(Bid-OrderOpenPrice()>WhenToMoveToBE*pips)
                    if(OrderOpenPrice()>OrderStopLoss()) 
                        OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(PipsToLockIn*pips),OrderTakeProfit(),0,CLR_NONE);        
   }     
   for(int s=OrdersTotal()-1; s >=0; s--)
      {
      if(OrderSelect(s,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber()==MagicNumber)
            if(OrderSymbol()==Symbol())
               if(OrderType()==OP_SELL)
                  if(OrderOpenPrice()-Ask>WhenToMoveToBE*pips)
                     if(OrderOpenPrice()<OrderStopLoss()) 
                         OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(PipsToLockIn*pips),OrderTakeProfit(),0,CLR_NONE);        
      }
}


//Trailing Stop Function---
//+------------------------------------------------------------------+
void AdjustTrail()

{
int buyStopCandle = iLowest(NULL,0,1,CandlesBack,0); 
int sellStopCandle = iHighest(NULL,0,2,CandlesBack,0); 

//+------------------------------------------------------------------+

//buy order section - This is where the stop will trail based upon a fixed point value stated on the EA. It will trail with price.
   for(int b=OrdersTotal()-1; b >=0; b--)
      {
      if(OrderSelect(b,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber()==MagicNumber)
            if(OrderSymbol()==Symbol())
               if(OrderType()==OP_BUY)
                  if (UseCandleTrail)
                    { if(IsNewCandle())
                         if(OrderStopLoss()<Low[buyStopCandle]-PadAmount*pips) // The [] is the candlestick in question - 1 being the first bar closed - 3 would qualify for 3 bar stop...
                             OrderModify(OrderTicket(),OrderOpenPrice(),Low[buyStopCandle]-PadAmount*pips,OrderTakeProfit(),0,CLR_NONE);
                    }         
                     else if(Bid-OrderOpenPrice()>WhenToTrail*pips)
                        if(OrderStopLoss()<Bid-pips*TrailAmount)
                           OrderModify(OrderTicket(),OrderOpenPrice(),Bid-(pips*TrailAmount),OrderTakeProfit(),0,CLR_NONE);
                        
      
      }
 //sell order section - This is where the stop will trail based upon a fixed point value stated on the EA. It will trail with price.     
    for(int s=OrdersTotal()-1; s >=0; s--)
      {
      if(OrderSelect(s,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber()==MagicNumber)
            if(OrderSymbol()==Symbol())
               if(OrderType()==OP_SELL)
                  if (UseCandleTrail)
                  {  if (IsNewCandle())
                        if(OrderStopLoss()>High[sellStopCandle]+PadAmount*pips)// The [] is the candlestick in question - 1 being the first bar closed - 3 would qualify for 3 bar stop...
                             OrderModify(OrderTicket(),OrderOpenPrice(),High[sellStopCandle]+PadAmount*pips,OrderTakeProfit(),0,CLR_NONE);
                  }
                   else if(OrderOpenPrice()-Ask>WhenToTrail*pips)
                     if(OrderStopLoss()>Ask+TrailAmount*pips||OrderStopLoss()==0)
                       OrderModify(OrderTicket(),OrderOpenPrice(),Ask+(pips*TrailAmount),OrderTakeProfit(),0,CLR_NONE);      

      }

}


//Moving Average Trailing Stop Function---
//+------------------------------------------------------------------+
void MA_Trail()

{
//+------------------------------------------------------------------+

//buy order section - This is where the stop will trail based upon a fixed point value stated on the EA. It will trail with price.
   for(int b=OrdersTotal()-1; b >=0; b--)
      {
      if(OrderSelect(b,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber()==MagicNumber)
            if(OrderSymbol()==Symbol())
               if(OrderType()==OP_BUY)
                  if (Use_MA_Trail)
                    { if(IsNewCandle())
                         if(OrderStopLoss()<iMA(NULL,0,60,0,1,0,0)-PadAmount*pips) 
                             OrderModify(OrderTicket(),OrderOpenPrice(),iMA(NULL,0,60,0,1,0,0)-PadAmount*pips,OrderTakeProfit(),0,CLR_NONE);
                    }         
                    
       }
 //sell order section - This is where the stop will trail based upon a fixed point value stated on the EA. It will trail with price.     
    for(int s=OrdersTotal()-1; s >=0; s--)
      {
      if(OrderSelect(s,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber()==MagicNumber)
            if(OrderSymbol()==Symbol())
               if(OrderType()==OP_SELL)
                  if (Use_MA_Trail)
                  {  if (IsNewCandle())
                        if(OrderStopLoss()>iMA(NULL,0,60,0,1,0,0)+PadAmount*pips)
                             OrderModify(OrderTicket(),OrderOpenPrice(),iMA(NULL,0,60,0,1,0,0)+PadAmount*pips,OrderTakeProfit(),0,CLR_NONE);
                  }
         }

}
  
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Check to see if any order open on this currency pair             |
//+------------------------------------------------------------------+

int OpenOrdersThisPair(string pair)
{
   int total=0;//this was set to 0
      for(int i=OrdersTotal()-1; i >= 0; i--)
         {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==pair) total++;
         }
         return (total);
}         

// If there is an order open, it will not place a new one^
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Insuring its a new candle function                               |
//+------------------------------------------------------------------+

bool IsNewCandle()
{
   static int  BarsOnChart=0;
   if (Bars == BarsOnChart)
   return (false);
   BarsOnChart = Bars;
   return (true);
}   

//+------------------------------------------------------------------+
//| Function that checks for an MA Cross                             |
//+------------------------------------------------------------------+

void CheckForMaTrade()
{

//+-----------------------------------------------------------------------------------------------------------------------+ 
    //Small and Big Fish on the H1 Time Frame.                                                                           |
//+-----------------------------------------------------------------------------------------------------------------------+              

/*
double PreviousFast  =  iMA(NULL,0,FastMa,FastMaShift,FastMaMethod,FastMaAppliedTo,2);
double CurrentFast   =  iMA(NULL,0,FastMa,FastMaShift,FastMaMethod,FastMaAppliedTo,1);
double PreviousSlow  =  iMA(NULL,0,SlowMa,SlowMaShift,SlowMaMethod,SlowMaAppliedTo,2);
double CurrentSlow   =  iMA(NULL,0,SlowMa,SlowMaShift,SlowMaMethod,SlowMaAppliedTo,1);
if(PreviousFast<PreviousSlow && CurrentFast>CurrentSlow)OrderEntry(0);
if(PreviousFast>PreviousSlow && CurrentFast<CurrentSlow)OrderEntry(1);
*/


   
   double PreviousSmallFish1  =  iMA(NULL,60,3,0,1,0,2); 
   double CurrentSmallFish1   =  iMA(NULL,60,3,0,1,0,1);
   double PreviousSmallFish2  =  iMA(NULL,60,5,0,1,0,2);
   double CurrentSmallFish2   =  iMA(NULL,60,5,0,1,0,1);
   double PreviousSmallFish3  =  iMA(NULL,60,8,0,1,0,2);
   double CurrentSmallFish3   =  iMA(NULL,60,8,0,1,0,1);
   double PreviousSmallFish4  =  iMA(NULL,60,10,0,1,0,2);
   double CurrentSmallFish4   =  iMA(NULL,60,10,0,1,0,1);  
   double PreviousSmallFish5  =  iMA(NULL,60,12,0,1,0,2);
   double CurrentSmallFish5   =  iMA(NULL,60,12,0,1,0,1);
   double PreviousSmallFish6  =  iMA(NULL,60,15,0,1,0,2);
   double CurrentSmallFish6   =  iMA(NULL,60,15,0,1,0,1);  
   
      double PreviousBigFish1  =  iMA(NULL,60,30,0,1,0,2); 
      double CurrentBigFish1   =  iMA(NULL,60,30,0,1,0,1);
      double PreviousBigFish2  =  iMA(NULL,60,35,0,1,0,2);
      double CurrentBigFish2   =  iMA(NULL,60,35,0,1,0,1);
      double PreviousBigFish3  =  iMA(NULL,60,40,0,1,0,2);
      double CurrentBigFish3   =  iMA(NULL,60,40,0,1,0,1);
      double PreviousBigFish4  =  iMA(NULL,60,45,0,1,0,2);
      double CurrentBigFish4   =  iMA(NULL,60,45,0,1,0,1);
      double PreviousBigFish5  =  iMA(NULL,60,50,0,1,0,2);
      double CurrentBigFish5   =  iMA(NULL,60,50,0,1,0,1);
      double PreviousBigFish6  =  iMA(NULL,60,60,0,1,0,2);
      double CurrentBigFish6   =  iMA(NULL,60,60,0,1,0,1);  
  
   
            if(PreviousBigFish1<CurrentBigFish2 && CurrentBigFish1>PreviousBigFish2)
               if(PreviousBigFish2<CurrentBigFish3 && CurrentBigFish2>PreviousBigFish3)
                  if(PreviousBigFish3<CurrentBigFish4 && CurrentBigFish3>PreviousBigFish4)
                     if(PreviousBigFish4<CurrentBigFish5 && CurrentBigFish4>PreviousBigFish5)
                        if(PreviousBigFish5<CurrentBigFish6 && CurrentBigFish5>PreviousBigFish6)  
                           if(PreviousSmallFish1<CurrentSmallFish2 && CurrentSmallFish1>PreviousSmallFish2)
                        if(PreviousSmallFish2<CurrentSmallFish3 && CurrentSmallFish2>PreviousSmallFish3)
                     if(PreviousSmallFish3<CurrentSmallFish4 && CurrentSmallFish3>PreviousSmallFish4)
                  if(PreviousSmallFish4<CurrentSmallFish5 && CurrentSmallFish4>PreviousSmallFish5)
                if(PreviousSmallFish5<CurrentSmallFish6 && CurrentSmallFish5>PreviousSmallFish6)int H1_Fish_Long;                                             //OrderEntry(0);
 
   
   if(PreviousBigFish1>CurrentBigFish2 && CurrentBigFish1<PreviousBigFish2)
      if(PreviousBigFish2>CurrentBigFish3 && CurrentBigFish2<PreviousBigFish3)
         if(PreviousBigFish3>CurrentBigFish4 && CurrentBigFish3<PreviousBigFish4)
            if(PreviousBigFish4>CurrentBigFish5 && CurrentBigFish4<PreviousBigFish5)
               if(PreviousBigFish5>CurrentBigFish6 && CurrentBigFish5<PreviousBigFish6)   
               if(PreviousSmallFish1>CurrentSmallFish2 && CurrentSmallFish1<PreviousSmallFish2)
            if(PreviousSmallFish2>CurrentSmallFish3 && CurrentSmallFish2<PreviousSmallFish3)
         if(PreviousSmallFish3>CurrentSmallFish4 && CurrentSmallFish3<PreviousSmallFish4)
       if(PreviousSmallFish4>CurrentSmallFish5 && CurrentSmallFish4<PreviousSmallFish5)
     if(PreviousSmallFish5>CurrentSmallFish6 && CurrentSmallFish5<PreviousSmallFish6)int H1_Fish_Short;                                                           //OrderEntry(1);
   
   
 
 

/*   
   double PreviousH4Fish1  =  iMA(NULL,240,3,0,1,0,2); 
   double CurrentH4Fish1   =  iMA(NULL,240,3,0,1,0,1);
   double PreviousH4Fish2  =  iMA(NULL,240,5,0,1,0,2);
   double CurrentH4Fish2   =  iMA(NULL,240,5,0,1,0,1);
   double PreviousH4Fish3  =  iMA(NULL,240,8,0,1,0,2);
   double CurrentH4Fish3   =  iMA(NULL,240,8,0,1,0,1);
   double PreviousH4Fish4  =  iMA(NULL,240,10,0,1,0,2);
   double CurrentH4Fish4   =  iMA(NULL,240,10,0,1,0,1);  
   double PreviousH4Fish5  =  iMA(NULL,240,12,0,1,0,2);
   double CurrentH4Fish5   =  iMA(NULL,240,12,0,1,0,1);
   double PreviousH4Fish6  =  iMA(NULL,240,15,0,1,0,2);
   double CurrentH4Fish6   =  iMA(NULL,240,15,0,1,0,1);  
 
      double PreviousBigH4Fish1  =  iMA(NULL,240,30,0,1,0,2); 
      double CurrentBigH4Fish1   =  iMA(NULL,240,30,0,1,0,1);
      double PreviousBigH4Fish2  =  iMA(NULL,240,35,0,1,0,2);
      double CurrentBigH4Fish2   =  iMA(NULL,240,35,0,1,0,1);
      double PreviousBigH4Fish3  =  iMA(NULL,240,40,0,1,0,2);
      double CurrentBigH4Fish3   =  iMA(NULL,240,40,0,1,0,1);
      double PreviousBigH4Fish4  =  iMA(NULL,240,45,0,1,0,2);
      double CurrentBigH4Fish4   =  iMA(NULL,240,45,0,1,0,1);
      double PreviousBigH4Fish5  =  iMA(NULL,240,50,0,1,0,2);
      double CurrentBigH4Fish5   =  iMA(NULL,240,50,0,1,0,1);
      double PreviousBigH4Fish6  =  iMA(NULL,240,60,0,1,0,2);
      double CurrentBigH4Fish6   =  iMA(NULL,240,60,0,1,0,1);  
      
 //string H4_Fish_Long()  
      
      if(PreviousBigH4Fish1<CurrentBigH4Fish2 && CurrentBigH4Fish1>PreviousBigH4Fish2)
         if(PreviousBigH4Fish2<CurrentBigH4Fish3 && CurrentBigH4Fish2>PreviousBigH4Fish3)
            if(PreviousBigH4Fish3<CurrentBigH4Fish4 && CurrentBigH4Fish3>PreviousBigH4Fish4)
               if(PreviousBigH4Fish4<CurrentBigH4Fish5 && CurrentBigH4Fish4>PreviousBigH4Fish5)
                  if(PreviousBigH4Fish5<CurrentBigH4Fish6 && CurrentBigH4Fish5>PreviousBigH4Fish6)  
                     if(PreviousH4Fish1<CurrentH4Fish2 && CurrentH4Fish1>PreviousH4Fish2)
                  if(PreviousH4Fish2<CurrentH4Fish3 && CurrentH4Fish2>PreviousH4Fish3)
               if(PreviousH4Fish3<CurrentH4Fish4 && CurrentH4Fish3>PreviousH4Fish4)
            if(PreviousH4Fish4<CurrentH4Fish5 && CurrentH4Fish4>PreviousH4Fish5)
         if(PreviousH4Fish5<CurrentH4Fish6 && CurrentH4Fish5>PreviousH4Fish6)int H4_Fish_Long;
                                              
     
//int H4_Fish_Short()
      
      if(PreviousBigH4Fish1>CurrentBigH4Fish2 && CurrentBigH4Fish1<PreviousBigH4Fish2)
         if(PreviousBigH4Fish2>CurrentBigH4Fish3 && CurrentBigH4Fish2<PreviousBigH4Fish3)
            if(PreviousBigH4Fish3>CurrentBigH4Fish4 && CurrentBigH4Fish3<PreviousBigH4Fish4)
               if(PreviousBigH4Fish4>CurrentBigH4Fish5 && CurrentBigH4Fish4<PreviousBigH4Fish5)
                  if(PreviousBigH4Fish5>CurrentBigH4Fish6 && CurrentBigH4Fish5<PreviousBigH4Fish6)  
                     if(PreviousH4Fish1>CurrentH4Fish2 && CurrentH4Fish1<PreviousH4Fish2)
                  if(PreviousH4Fish2>CurrentH4Fish3 && CurrentH4Fish2<PreviousH4Fish3)
               if(PreviousH4Fish3>CurrentH4Fish4 && CurrentH4Fish3<PreviousH4Fish4)
            if(PreviousH4Fish4>CurrentH4Fish5 && CurrentH4Fish4<PreviousH4Fish5)
         if(PreviousH4Fish5>CurrentH4Fish6 && CurrentH4Fish5<PreviousH4Fish6)int H4_Fish_Short;           
   
   
   
   
   double PreviousD1Fish1  =  iMA(NULL,1440,3,0,1,0,2); 
   double CurrentD1Fish1   =  iMA(NULL,1440,3,0,1,0,1);
   double PreviousD1Fish2  =  iMA(NULL,1440,5,0,1,0,2);
   double CurrentD1Fish2   =  iMA(NULL,1440,5,0,1,0,1);
   double PreviousD1Fish3  =  iMA(NULL,1440,8,0,1,0,2);
   double CurrentD1Fish3   =  iMA(NULL,1440,8,0,1,0,1);
   double PreviousD1Fish4  =  iMA(NULL,1440,10,0,1,0,2);
   double CurrentD1Fish4   =  iMA(NULL,1440,10,0,1,0,1);  
   double PreviousD1Fish5  =  iMA(NULL,1440,12,0,1,0,2);
   double CurrentD1Fish5   =  iMA(NULL,1440,12,0,1,0,1);
   double PreviousD1Fish6  =  iMA(NULL,1440,15,0,1,0,2);
   double CurrentD1Fish6   =  iMA(NULL,1440,15,0,1,0,1);  
 
      double PreviousBigD1Fish1  =  iMA(NULL,1440,30,0,1,0,2); 
      double CurrentBigD1Fish1   =  iMA(NULL,1440,30,0,1,0,1);
      double PreviousBigD1Fish2  =  iMA(NULL,1440,35,0,1,0,2);
      double CurrentBigD1Fish2   =  iMA(NULL,1440,35,0,1,0,1);
      double PreviousBigD1Fish3  =  iMA(NULL,1440,40,0,1,0,2);
      double CurrentBigD1Fish3   =  iMA(NULL,1440,40,0,1,0,1);
      double PreviousBigD1Fish4  =  iMA(NULL,1440,45,0,1,0,2);
      double CurrentBigD1Fish4   =  iMA(NULL,1440,45,0,1,0,1);
      double PreviousBigD1Fish5  =  iMA(NULL,1440,50,0,1,0,2);
      double CurrentBigD1Fish5   =  iMA(NULL,1440,50,0,1,0,1);
      double PreviousBigD1Fish6  =  iMA(NULL,1440,60,0,1,0,2);
      double CurrentBigD1Fish6   =  iMA(NULL,1440,60,0,1,0,1);       
      
      
//int D1_Fish_Long()
      
       if(PreviousBigD1Fish1<CurrentBigD1Fish2 && CurrentBigD1Fish1>PreviousBigD1Fish2)
         if(PreviousBigD1Fish2<CurrentBigD1Fish3 && CurrentBigD1Fish2>PreviousBigD1Fish3)
            if(PreviousBigD1Fish3<CurrentBigD1Fish4 && CurrentBigD1Fish3>PreviousBigD1Fish4)
               if(PreviousBigD1Fish4<CurrentBigD1Fish5 && CurrentBigD1Fish4>PreviousBigD1Fish5)
                  if(PreviousBigD1Fish5<CurrentBigD1Fish6 && CurrentBigD1Fish5>PreviousBigD1Fish6) 
                      if(PreviousD1Fish1<CurrentD1Fish2 && CurrentD1Fish1>PreviousD1Fish2)
                   if(PreviousD1Fish2<CurrentD1Fish3 && CurrentD1Fish2>PreviousD1Fish3)
                 if(PreviousD1Fish3<CurrentD1Fish4 && CurrentD1Fish3>PreviousD1Fish4)
             if(PreviousD1Fish4<CurrentD1Fish5 && CurrentD1Fish4>PreviousD1Fish5)
          if(PreviousD1Fish5<CurrentD1Fish6 && CurrentD1Fish5>PreviousD1Fish6)int D1_Fish_Long;
        
 
  
 
         
     if(PreviousBigD1Fish1>CurrentBigD1Fish2 && CurrentBigD1Fish1<PreviousBigD1Fish2)
          if(PreviousBigD1Fish2>CurrentBigD1Fish3 && CurrentBigD1Fish2<PreviousBigD1Fish3)
             if(PreviousBigD1Fish3>CurrentBigD1Fish4 && CurrentBigD1Fish3<PreviousBigD1Fish4)
                if(PreviousBigD1Fish4>CurrentBigD1Fish5 && CurrentBigD1Fish4<PreviousBigD1Fish5)
                   if(PreviousBigD1Fish5>CurrentBigD1Fish6 && CurrentBigD1Fish5<PreviousBigD1Fish6) 
                      if(PreviousD1Fish1>CurrentD1Fish2 && CurrentD1Fish1<PreviousD1Fish2)
                   if(PreviousD1Fish2>CurrentD1Fish3 && CurrentD1Fish2<PreviousD1Fish3)
              if(PreviousD1Fish3>CurrentD1Fish4 && CurrentD1Fish3<PreviousD1Fish4)
           if(PreviousD1Fish4>CurrentD1Fish5 && CurrentD1Fish4<PreviousD1Fish5)
      if(PreviousD1Fish5>CurrentD1Fish6 && CurrentD1Fish5<PreviousD1Fish6)int D1_Fish_Short;
        
    
   
   
  
   if (H1_Fish_Long>H4_Fish_Long && H4_Fish_Long>D1_Fish_Long)OrderEntry(0); 
   if (H1_Fish_Short<H4_Fish_Short && H4_Fish_Short<D1_Fish_Short)OrderEntry(1);    
   
   
   }
*/
 
} 

void ConsolidatedTrigger()
{
int iBars (NULL,0)); 
double CountingBars = 8;
Bars




}


          
//+------------------------------------------------------------------+  
//+------------------------------------------------------------------+
//| Order Enter Function                                             |
//+------------------------------------------------------------------+

void OrderEntry (int direction)
{    
   double LotSize=0;
   double Equity=AccountEquity();
   double RiskedAmount=Equity*RiskPercent*0.01;
   int buyStopCandle = iLowest(NULL,0,1,CandlesBack,1); 
   int sellStopCandle = iHighest(NULL,0,2,CandlesBack,1);
   double buy_stop_price = iMA(NULL,0,21,0,1,0,0)-PadAmount*pips;
   double pips_to_bsl = Ask-buy_stop_price;
   double buy_takeprofit_price = Ask+pips_to_bsl*RewardRatio;   
   double sell_stop_price = iMA(NULL,0,21,0,1,0,0)+PadAmount*pips;
   double pips_to_ssl = sell_stop_price-Bid;
   double sell_takeprofit_price = Bid-pips_to_ssl*RewardRatio;   
   
   if (direction==0)//<< "0" pushes out a Buy direction
   {
      double bsl=buy_stop_price;
      double btp=buy_takeprofit_price;
      //LotSize = (100/(0.00500/0.00010))/10
      LotSize = (RiskedAmount/(pips_to_bsl/pips))/10;
      if(OpenOrdersThisPair(Symbol())==0)int buyticket = OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,0,0,NULL,MagicNumber,0,Green);
      if(buyticket>0)OrderModify(buyticket,OrderOpenPrice(),bsl,btp,0,CLR_NONE);
   }
            
   if (direction==1) //<< "1" pushes out a Sell direction
   {
      double ssl=sell_stop_price;
      double stp=sell_takeprofit_price; 
      //LotSize = (100/(0.00500/0.00010))/10;
      LotSize = (RiskedAmount/(pips_to_ssl/pips))/10;    
      if(OpenOrdersThisPair(Symbol())==0)int sellticket = OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,0,0,NULL,MagicNumber,0,Red);
      if(sellticket>0)OrderModify(sellticket,OrderOpenPrice(),ssl,stp,0,CLR_NONE);
   }
}

return(0);

//+------------------------------------------------------------------+  



//+------------------------------------------------------------------+  